Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 590756 - media-libs/rtaudio-4.1.2 - ../.libs/librtaudio.so: error: undefined reference to 'pa_strerror'
Summary: media-libs/rtaudio-4.1.2 - ../.libs/librtaudio.so: error: undefined reference...
Status: CONFIRMED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal with 1 vote (vote)
Assignee: Professional Audio Applications Maintainers
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: gold-tracker
  Show dependency tree
 
Reported: 2016-08-08 11:13 UTC by Adrian Bassett
Modified: 2019-12-22 11:42 UTC (History)
2 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Adrian Bassett 2016-08-08 11:13:56 UTC
media-libs/rtaudio-4.1.2 built with following USE flags fails with ld.gold:

media-libs/rtaudio-4.1.2::gentoo [4.0.12-r1::gentoo] USE="alsa jack pulseaudio -doc -static-libs"

log snippet:

libtool: link: x86_64-pc-linux-gnu-g++-5.4.0 -Wall -I.. -mstackrealign -fomit-frame-pointer -O2 -march=core2 -mtune=core2 -mmmx -msse -msse2 -msse3 -mssse3 -msse4.1 -mfpmath=sse -pipe -frecord-gcc-switches -Wall -Wextra -O2 -march=core2 -mtune=core2 -mmmx -msse -msse2 -msse3 -mssse3 -msse4.1 -mfpmath=sse -pipe -frecord-gcc-switches -Wl,-O1 -o .libs/audioprobe audioprobe.o  -Wl,--as-needed ../.libs/librtaudio.so -lpulse-simple -lasound /usr/lib64/libjack.so -ldb -lm -lpthread -ldl
../.libs/librtaudio.so: error: undefined reference to 'pa_strerror'
collect2: error: ld returned 1 exit status

pulseaudio is at media-sound/pulseaudio-9.0

Builds successfully with ld.bfd.
Comment 1 Red 2019-05-18 05:45:21 UTC
Same here.

It wouldn't build for me with LD=ld.bfd in /etc/portage/env though, I had to set binutils-config --linker ld.bfd prior to emerge.
Comment 2 Adrian Bassett 2019-05-18 08:58:10 UTC
(In reply to Red from comment #1)
> Same here.
> 
> It wouldn't build for me with LD=ld.bfd in /etc/portage/env though, I had to
> set binutils-config --linker ld.bfd prior to emerge.

I'd forgotten about this bug so thought I'd re-run a build.  As I no longer had rtaudio on my system it was a new compile with the following in the various portage environment files.

/etc/portage/package.env:
media-libs/rtaudio ld.bfd.env

/etc/portage/env/ld.bfd.env:
LD="ld.bfd"
CFLAGS="${CFLAGS} -fuse-ld=bfd"
CXXFLAGS="${CXXFLAGS} -fuse-ld=bfd"
LDFLAGS="${LDFLAGS} -fuse-ld=bfd"

It ran OK to completion for me (as also for rtaudio-5.0.0).  Don't know if this helps.
Comment 3 Red 2019-05-21 23:34:02 UTC
(In reply to Adrian Bassett from comment #2)
> (In reply to Red from comment #1)
> > Same here.
> > 
> > It wouldn't build for me with LD=ld.bfd in /etc/portage/env though, I had to
> > set binutils-config --linker ld.bfd prior to emerge.
> 
> I'd forgotten about this bug so thought I'd re-run a build.  As I no longer
> had rtaudio on my system it was a new compile with the following in the
> various portage environment files.
> 
> /etc/portage/package.env:
> media-libs/rtaudio ld.bfd.env
> 
> /etc/portage/env/ld.bfd.env:
> LD="ld.bfd"
> CFLAGS="${CFLAGS} -fuse-ld=bfd"
> CXXFLAGS="${CXXFLAGS} -fuse-ld=bfd"
> LDFLAGS="${LDFLAGS} -fuse-ld=bfd"
> 
> It ran OK to completion for me (as also for rtaudio-5.0.0).  Don't know if
> this helps.

Yep, needed to change the flags too. Thank you!
Comment 4 Miroslav Šulc gentoo-dev 2019-12-21 21:10:30 UTC
if i get it right, the issue was in misconfiguration of the build process, so closing this bug. if i got it wrong, please re-open.
Comment 5 Red 2019-12-22 01:57:07 UTC
(In reply to Miroslav Šulc from comment #4)
> if i get it right, the issue was in misconfiguration of the build process,
> so closing this bug. if i got it wrong, please re-open.

This is a bug relating to the use of the ld.gold linker. It should be reopened and added to the tracker bug 269315.
Comment 6 Miroslav Šulc gentoo-dev 2019-12-22 08:00:03 UTC
ok. what's the fix then?
Comment 7 Adrian Bassett 2019-12-22 10:57:13 UTC
(In reply to Red from comment #5)
> (In reply to Miroslav Šulc from comment #4)
> > if i get it right, the issue was in misconfiguration of the build process,
> > so closing this bug. if i got it wrong, please re-open.
> 
> This is a bug relating to the use of the ld.gold linker. It should be
> reopened and added to the tracker bug 269315.

Indeed.  However, this bug still appears to block #269315 (from 2016-08-08).
Comment 8 Adrian Bassett 2019-12-22 11:06:04 UTC
(In reply to Miroslav Šulc from comment #6)
> ok. what's the fix then?

I don't know.  The rtaudio project, however, is still active (there appears to be a version 5.1.0) and it might be appropriate for the gentoo maintainer to contact the developer for their comments (home page https://www.music.mcgill.ca/~gary/rtaudio/index.html).

There are a number of ebuilds in portage which have to address the same issue and  these may offer some guidance.

As I indicated in comment#2, I no longer have rtaudio on my system.
Comment 9 Miroslav Šulc gentoo-dev 2019-12-22 11:42:59 UTC
thanks. i will see what i can do about it when i find some time for that. i am not familiar with ld.gold at all so will to get some information first, but you are right that the other already resolved bugs should give some guidance.